version: '3.4'

x-postgres-env: &postgres-env
  POSTGRES_DB: pgdb
  POSTGRES_USER: pguser
  POSTGRES_PASSWORD: pgpass

services:

  docker.lint:
    image: hadolint/hadolint:latest-debian
    command: ["bash", "-c", "find /data -name '*Dockerfile' -exec sh -c 'for n; do hadolint \"$$n\" || exit 1; done;' sh {} +"]
    volumes:
    - ./:/data

  shell.lint:
    image: koalaman/shellcheck-alpine
    command: ["sh", "-c", "find /data -name '*.sh' -exec sh -c 'for n; do shellcheck \"$$n\" || exit 1; done;' sh {} +"]
    volumes:
      - ./:/data

  shell.test_pg:
    image: postgres:11
    environment:
      <<: *postgres-env

  shell.test:
    depends_on:
      - shell.test_pg
    build:
      context: .docker/
      dockerfile: shell.test.Dockerfile
    command: ["bash", "-c", "find /data -name '*.spec.sh' -exec sh -c 'for n; do sh \"$$n\" || exit 1; done;' sh {} +"]
    # entrypoint: bash
    # tty: true
    volumes:
      - ./:/data
    environment:
      ROOT_SCRIPTS_DIR: /data
      POSTGRES_HOST: shell.test_pg
      <<: *postgres-env
